#ifndef NORMAL_MAPPING_H
#define NORMAL_MAPPING_H

#include <Cg/cgGL.h>	//include the OpenGL runtime API (includes cg.h)
#include <iostream>		//include the C++ standard I/O streams
#include <string>		//include the standard windows string library

//#include "Camera.h"

using namespace std;
using namespace Eigen;



class NormalMapping
{
	public:
		NormalMapping(Vector3f *lightPosition);
		~NormalMapping(void);
				 
		static void enableShader(void);
		static void disableShader(void);
		static void setShaderParameters(void);

	protected:

	private:
		static CGprogram *cgVertexProgram;
		static CGprogram *cgFragmentProgram;
		static CGprofile *cgVertexProfile;
		static CGprofile *cgFragmentProfile;

		static CGparameter cgModelViewProj;
		static CGparameter cgModelViewIT;
		static CGparameter cgLightPosition;
		static CGparameter cgNormalMap;

		static CGcontext cgContext;	//A context is a container for multiple Cg programs.

		static GLuint normalMapID;

		static Vector3f *lightPosition;

		static void initCg(CGprofile *cgVertexProfile,
                           CGprofile *cgFragmentProfile,
						   CGprogram *cgVertexProgram,
                           CGprogram *cgFragmentProgram);

		static void loadNormalMap(void);
		static void cgErrorCallback(void);

};
#endif //NORMAL_MAPPING_H
